import csv
from Disciplinas import Disciplinas
from Docentes import Docentes
from Cursos import Cursos

from functools import reduce

def main():
    listaDocentes = LerArqDocentes()
    listaCursos = LerArqCursos()
    listaDisciplinas = LerArqDisciplinas(listaDocentes, listaCursos)
    GeraAlocacao(listaDisciplinas)
    GeraRha(listaDisciplinas)

def LerArqDisciplinas(listaDocentes, listaCursos):
    path = 'aulas.csv'
    file = open(path, newline='', encoding="utf8")
    reader = csv.reader(file, delimiter = ';')

    header = next(reader)
    listaDisciplinas = []

    for row in reader:
        codigo = str(row[0]).strip()
        nome = str(row[1]).strip()
        codigoDocente = str(row[2]).strip()
        for ld in listaDocentes:
            if ld.codigo == codigoDocente:
                docente = ld
        cargaSemanal = str(row[3]).strip()
        cargaSemestral = str(row[4]).strip()
        codigoCurso = str(row[5]).strip()
        for lc in listaCursos:
            if lc.codigo == codigoCurso:
                curso = lc
        disciplina = Disciplinas(docente, codigo, nome, cargaSemestral, cargaSemanal, curso)
        listaDisciplinas.append(disciplina)

    return listaDisciplinas

def LerArqDocentes():
    path = 'docentes.csv'
    file = open(path, newline='', encoding="utf8")
    reader = csv.reader(file, delimiter = ';')

    header = next(reader)
    listaDocentes = []

    for row in reader:
        codigo = str(row[0]).strip()
        nome = str(row[1]).strip()
        departamento = str(row[2]).strip()
        docente = Docentes(codigo, nome, departamento)
        listaDocentes.append(docente)

    return listaDocentes

def LerArqCursos():
    path = 'cursos.csv'
    file = open(path, newline='', encoding="utf8")
    reader = csv.reader(file, delimiter = ';')

    header = next(reader)
    listaCursos = []

    for row in reader:
        codigo = str(row[0]).strip()
        nome = str(row[1]).strip()
        graduacao = str(row[2]).strip()
        pos = str(row[3]).strip()
        curso = Cursos(codigo, nome, graduacao, pos)
        listaCursos.append(curso)

    return listaCursos

def OrganizaLista(listaDisciplinas):
    lista = []
    for idx, ld in enumerate(listaDisciplinas):
        if idx == 0:
            cargaSemestral = int(ld.cargaSemestral)
        elif listaDisciplinas[idx-1].curso.codigo == ld.curso.codigo and listaDisciplinas[idx-1].docente.nome == ld.docente.nome:
            cargaSemestral += int(ld.cargaSemestral)
        else:
            pre = listaDisciplinas[idx-1]
            pre.cargaSemestral = cargaSemestral
            lista.append(pre)
            cargaSemestral = int(ld.cargaSemestral)
            if idx == len(listaDisciplinas) - 1:
                lista.append(ld)

    return lista


def GeraAlocacao(listaDisciplinas):
    listaDisciplinas.sort(key=lambda ld: (ld.docente.nome, ld.codigo)) # sort pelo nome do docente

    with open('3-alocacao.csv','w', newline='',encoding="utf8") as csv_file:
        fieldnames = ['<nome do docente>','<código da disciplina>','<nome da disciplina>','<carga horária semestral>']
        writer = csv.DictWriter(csv_file, fieldnames=fieldnames,delimiter = ';')

        writer.writeheader()
        for l in listaDisciplinas:
            writer.writerow({'<nome do docente>': l.docente.nome, '<código da disciplina>': l.codigo, '<nome da disciplina>': l.nome,
            '<carga horária semestral>': l.cargaSemestral})

def GeraRha(listaDisciplinas):
    listaDisciplinas.sort(key=lambda ld: (ld.docente.departamento.casefold(), ld.docente.nome, ld.curso.nome))
    # for l in listaDisciplinas:
    #     print(l.docente.departamento, l.docente.nome, l.curso.codigo, l.cargaSemestral)
    lista = OrganizaLista(listaDisciplinas)
    # for l in lista:
    #     print(l.cargaSemestral)

    with open('2-rha.csv','w', newline='',encoding="utf8") as csv_file:
        fieldnames = ['<nome do departamento>','<nome do docente>','<código do curso>','<nome do curso>', '<total horas semestrais aulas>']
        writer = csv.DictWriter(csv_file, fieldnames=fieldnames,delimiter = ';')

        writer.writeheader()
        for l in lista:
            writer.writerow({'<nome do departamento>': l.docente.departamento, '<nome do docente>': l.docente.nome, '<código do curso>': l.curso.codigo,
            '<nome do curso>': l.curso.nome, '<total horas semestrais aulas>': l.cargaSemestral })

main()